#!/bin/bash

#exit 0
#echo "PATCH-IMG: $*"

#------------------------------------------------------------------------------
# scan options

fast=
verbose=0
support_strap=0
support_title=0

while (($#))
do
    if [[ ${1:0:1} == - ]]
    then
	[[ $1 = -f || $1 = --fast    ]] && fast=--fast
	[[ $1 = -v || $1 = --verbose ]] && verbose=1
	[[ $1 = -s=strap ]] && support_strap=1
	[[ $1 = -s=title ]] && support_title=1
    else
	mode="$1"
    fi
    shift
done

mode="${mode%+}"

#------------------------------------------------------------------------------
# setup

srcdir=files/_Wiimm/img-patch
temp=.temp.d
strap_base=files/Boot/Strap

title1=$srcdir/title1.png
title2=$srcdir/title2.png
titlefile=files/Scene/UI/Title.szs
titledir="$temp/title/timg"
titleprefix=tt_title_screen_
titlelist="mario mario0 mario2 luigi peachi koopa"

done=0

#------------------------------------------------------------------------------
# strap files

strap_a="$srcdir/$mode/strap-a.png"
strap_b="$srcdir/$mode/strap-b.png"
strap_tit="$srcdir/strap-title.png"
strap_sig="$srcdir/signature.png"

[[ -s $strap_a ]] || strap_a="$srcdir/strap-a.png"
[[ -s $strap_b ]] || strap_b="$srcdir/strap-b.png"

if [[ $support_strap = 1 && -s $strap_a && -s $strap_b && -s $strap_tit && -s $strap_sig ]]
then
    ((done++)) || printf " * patch images, mode=%s %s\n" "$mode" "$fast"
    count=0
    for strap in $strap_base/*/*.szs
    do
	((verbose)) && printf " - Create strap file %s\n" "$strap"
	if ((!count++))
	then
	    first="$strap"
	    rm -rf "$temp"
	    wszst extract -q --raw "$first" -D "$temp"
	    wimgt convert -q "$temp/Textures(NW4R)"/strapA_* \
			-P "fg=$strap_a" \
			-P "fg=$strap_tit" \
			-P "fg.b=$strap_sig"
		    
	    wimgt convert -q "$temp/Textures(NW4R)"/strapB_* \
			-P "fg=$strap_b" \
			-P "fg=$strap_tit" \
			-P "fg.b=$strap_sig"
	    wszst create -orq "$temp" -d "$strap" $fast
	    #mv "$temp" "$temp.strap"
	    rm -rf "$temp"
	else
	    ln -f "$first" "$strap"
	fi
    done
    printf "    - %u strap files created\n" $count
fi

#------------------------------------------------------------------------------
# strap files

if [[ $support_title = 1 && -s $title1 && -s $title2 ]]
then
    ((done++)) || printf " * patch images, mode=%s %s\n" "$mode" "$fast"
    count=0
    rm -rf "$temp"
    wszst extract -q --raw "$titlefile" -D "$temp"
    for t in $titlelist
    do
	f="$titledir/${titleprefix}${t}.tpl"
	if [[ -s $f ]]
	then
	    ((verbose)) && printf " - Patch image %s\n" "$f"
	    wimgt convert -q "$f" -P "fg=$title1"
	    let count++
	fi

	f="$titledir/${titleprefix}${t}_bokeboke.tpl"
	if [[ -s $f ]]
	then
	    ((verbose)) && printf " - Patch image %s\n" "$f"
	    wimgt convert -q "$f" -P "fg=$title2"
	    let count++
	fi
    done
    wszst update -orq "$titlefile" -s "$temp" $fast
    printf "    - %u title screens patched\n" $count
    rm -rf "$temp"
fi

exit 0
