#!/bin/bash
# (c) wiimm (at) wiimm.de -- 2012-11-14
#echo ">>> post-patch-mkw <<<"

FAST=
[[ $WSZST_FAST = 1 || $1 == --fast ]] && FAST=--fast

#--- infos

# 'ln' creates a hard link (faster than copying)
# 'ln -f' same but remove the destination first to avoid conflicts


#--- not needed  (ignore .svn entires)

rm -f include.fst


#--- create track files

function setup_autoadd
{
    if [[ ! -d ./auto-add ]]
    then
	echo " * create patch library"
	wszst autoadd -q ./files/Race/Course/ -D ./auto-add
    fi
}

if [[ -d ./files/Race/Course/.wu8 ]]
then
    setup_autoadd
    echo " * patch track files (takes a long time) $FAST"
    wszst -iq compress ./files/Race/Course/.wu8/*.wu8 --szs -rd %P/../%N.szs $FAST
fi


if [[ -d ./files/Race/Course/.wbz ]]
then
    setup_autoadd
    echo " * create track files (takes a long time) $FAST"
    wszst -iq compress ./files/Race/Course/.wbz/*.wbz --szs -rd %P/../%N.szs $FAST
fi

if [[ -s ./_d.list ]]
then
    echo " * create _d versions of the track files"
    while read f
    do
	#echo ln -f "${f}.szs" "${f}_d.szs"
	ln -f "${f}.szs" "${f}_d.szs"
    done <./_d.list
fi


#--- create kart files

if [[ -d ./files/Race/Kart/.wu8 ]]
then
    setup_autoadd
    echo " * patch kart files (takes a medium time) $FAST"
    wszst -iq compress ./files/Race/Kart/.wu8/*.wu8 --szs -rd %P/../%N.szs $FAST
fi

if [[ -d ./files/Race/Kart/.wbz ]]
then
    setup_autoadd
    echo " * create kart files (takes a medium time) $FAST"
    wszst -iq compress ./files/Race/Kart/.wbz/*.wbz --szs -rd %P/../%N.szs $FAST
fi


#--- replace videos to reduce size

v1=./files/thp/title
v2=./files/thp/ending
vsrc=$v1/top_menu.thp

if [[ -f $vsrc ]]
then
    for f in $v1/*.thp $v2/*.thp
    do
	[[ -f $f && $vsrc != $f ]] && ln -f "$vsrc" "$f"
    done
fi


#--- call sound assigning script

[[ -s ./assign-mkw-sound.sh ]] && bash ./assign-mkw-sound.sh ./mkw-sound.tab files/sound/strm


#--- call message patching script

[[ -s ./patch-bmg.sh ]] && bash ./patch-bmg.sh --verbose $REV_SUPPORT $CFG_MSGLANG "$@"


#--- call image patching script

[[ -s ./patch-img.sh ]] && bash ./patch-img.sh $REV_SUPPORT $CFG_MSGLANG "$@"


#--- exit with success status

true

